package example.android.dialogsample;

import java.util.Calendar;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.app.ProgressDialog;
import android.app.TimePickerDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.TimePicker;

public class DialogSampleActivity extends Activity {
    TextView label = null;
    
    // onCreate\bh(ʏ\Cxgnh)
    @Override
    public void onCreate(Bundle savedInstanceState) {
        // X[p[NXonCreate\bhĂяo
        super.onCreate(savedInstanceState);
        // CAEgݒt@C̎w
        setContentView(R.layout.dialogsample);
        
        // \x擾
        label = (TextView)findViewById(R.id.label_dialogtext);
        
        // ʏ_CAO\{^̃NbNXi[ݒ
        Button dialogBtn = (Button)findViewById(R.id.dialogButton);   
        dialogBtn.setTag("dialog");
        dialogBtn.setOnClickListener(new ButtonClickListener()); 
        
        // eLXg_CAO\{^̃NbNXi[ݒ
        Button txtDialogBtn = (Button)findViewById(R.id.textDialogButton);
        txtDialogBtn.setTag("textDialog");
        txtDialogBtn.setOnClickListener(new ButtonClickListener());   
        
        // PI_CAO\{^̃NbNXi[ݒ
        Button SingleSelectDialogBtn = (Button)findViewById(R.id.singleSelectDialogButton);
        SingleSelectDialogBtn.setTag("singleSelectDialog");
        SingleSelectDialogBtn.setOnClickListener(new ButtonClickListener()); 
       
        // tI_CAO\{^̃NbNXi[ݒ
        Button DatePickerDialogBtn = (Button)findViewById(R.id.datePickerDialogButton);
        DatePickerDialogBtn.setTag("datePickerDialogBtn");
        DatePickerDialogBtn.setOnClickListener(new ButtonClickListener());
        
        // ԑI_CAO\{^̃NbNXi[ݒ
        Button TimePickerDialogBtn = (Button)findViewById(R.id.timePickerDialogButton);
        TimePickerDialogBtn.setTag("timePickerDialogBtn");
        TimePickerDialogBtn.setOnClickListener(new ButtonClickListener());
        
        // vOXo[_CAO\{^̃NbNXi[ݒ
        Button ProgressDialogBtn = (Button)findViewById(R.id.progressDialogButton);
        ProgressDialogBtn.setTag("progressDialogBtn");
        ProgressDialogBtn.setOnClickListener(new ButtonClickListener());
        
    }
    
    // NbNXi[`
    class ButtonClickListener implements OnClickListener{
        // onClick\bh({^NbNCxgnh)
        public void onClick(View v) {
            String tag = (String)v.getTag();
            if (tag.equals("dialog")) {
                showDialog();
            } else if (tag.equals("textDialog")) {
                showTextDialog();
            } else if (tag.equals("singleSelectDialog")) {
                showSingleSelectDialog();
            } else if (tag.equals("datePickerDialogBtn")) {
                showDatePickerDialog();
            } else if (tag.equals("timePickerDialogBtn")) {
                showTimePickerDialog();
            } else if (tag.equals("progressDialogBtn")) {
                showProgressDialog();
            } 
        }
    }
    
    // ʏ_CAO̕\
    private void showDialog() {
        AlertDialog.Builder dialog = new AlertDialog.Builder(DialogSampleActivity.this);
        dialog.setTitle("ʏ_CAO");
        dialog.setMessage("IĂB");
        dialog.setPositiveButton("OK",new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
                label.setText("ʏ_CAOFOKI܂B");
            }
        });
        dialog.setNegativeButton("NG", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
                label.setText("ʏ_CAOFNGI܂B");
            }
        });
        dialog.show();
    }
    
    // eLXg_CAO̕\
    public void showTextDialog() {  
        final EditText editText=new EditText(DialogSampleActivity.this);  
        AlertDialog.Builder dialog = new AlertDialog.Builder(DialogSampleActivity.this);
        dialog.setTitle("eLXg_CAO"); 
        dialog.setMessage("eLXg͂ĂB");
        dialog.setView(editText);  
        dialog.setPositiveButton("OK",new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
                label.setText("eLXg_CAOF" + editText.getText().toString() + "͂܂B");
            }
        });  
        dialog.show();  
    }  
    
    // PI_CAO̕\
    final String[] items = new String[]{"","",""};
    int which = 0;
    public void showSingleSelectDialog() {      
        AlertDialog.Builder dialog = new AlertDialog.Builder(DialogSampleActivity.this);  
        dialog.setTitle("PI_CAO");  
        dialog.setSingleChoiceItems(items
               ,0
               ,new DialogInterface.OnClickListener() {        
                    public void onClick(DialogInterface dialog, int whichButton) {
                        which = whichButton;
                    }
                }
        );
        
        dialog.setPositiveButton("OK",new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog,int whichButton) {
                String selected = items[which];
                label.setText("PI_CAOF" + selected + "͂܂B");
            }
        });  
        dialog.show(); 
    }
    
    // tI_CAO̕\
    public void showDatePickerDialog() {
        Calendar cal = Calendar.getInstance();
        
        DatePickerDialog dialog = new DatePickerDialog(DialogSampleActivity.this
                ,new DatePickerDialog.OnDateSetListener() { 
                    @Override
                    public void onDateSet(DatePicker picker, int year, int month, int day) {
                        label.setText("tI_CAOF" + year + "N" + (month+1) + "" + day + "");
                    }
                }
                ,cal.get(Calendar.YEAR)
                ,cal.get(Calendar.MONTH)
                ,cal.get(Calendar.DAY_OF_MONTH)
        );
        dialog.show(); 
    }
    
    // ԑI_CAO̕\
    public void showTimePickerDialog() {
        TimePickerDialog dialog = new TimePickerDialog(DialogSampleActivity.this
                ,new TimePickerDialog.OnTimeSetListener() { 
                    @Override
                    public void onTimeSet(TimePicker picker, int hour, int min) {
                        label.setText("ԑI_CAOF" + hour + "" + min + "");
                    }
                }
                ,0
                ,0
                ,true
        );
        dialog.show();
    }
    
    // vOXo[_CAO̕\
    ProgressDialog  dialog;
    public void showProgressDialog() {
        dialog = new ProgressDialog (DialogSampleActivity.this);
        dialog.setTitle("vOXo[_CAO");
        dialog.setMessage("΂炭҂EE");
        dialog.setIndeterminate(false);
        dialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
        //dialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
        dialog.setMax(100);  
        dialog.setCancelable(false);
        dialog.setOnCancelListener(new DialogInterface.OnCancelListener() {   
              public void onCancel(DialogInterface dialog) {
              }
        });
 
        dialog.show(); 
        new Thread(new Runnable(){
            @Override
            public void run(){
                try{
                    for(int i=0; i< dialog.getMax(); i++){
                        dialog.setProgress(i);
                        Thread.sleep(100);
                    }
                }catch(Exception e){
                    
                }
                dialog.dismiss();
            }
        }).start();     
    }
}
