package example.android.bindservicesample;

import java.util.Timer;
import java.util.TimerTask;

import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.os.RemoteCallbackList;
import android.os.RemoteException;
import android.util.Log;

public class BindServiceSampleService extends Service {
    // R[obNǗXg
    private final RemoteCallbackList<BindActivityAIDL> callbackList 
                            = new RemoteCallbackList<BindActivityAIDL>();
    // TimerIuWFNg
    private Timer timer = null;
    // oߎ
    private int countTime;	
    
    // onCreate\bh(T[rXNCxgnh)
    @Override
    public void onCreate() {
        super.onCreate();
        
        // ^C}[ƌoߎԏ
        timer = new Timer();
        countTime = 0;
        
        // ^C}[ݒ(10bƂrun\bhĂяo)
        timer.schedule(task, 10000, 10000);
    }

    // onBind\bh(oChCxgnh)
    @Override
    public IBinder onBind(Intent intent) {
        if (BindServiceAIDL.class.getName().equals(intent.getAction())) {
            return serviceCallbackIf;
        }
        return null;
    }

    // onUnbind\bh(AoChCxgnh)
    @Override
    public boolean onUnbind(Intent intent) {

        // ^C}[ݒ
        timer.cancel();
        timer.purge();

        return super.onUnbind(intent);
    }
       
    //  T[rXɘAgC^[tF[XIuWFNg
    private BindServiceAIDL.Stub serviceCallbackIf = new BindServiceAIDL.Stub() {
        public void registerCallback(BindActivityAIDL callback) {
            // CallbackXgɓo^
            callbackList.register(callback);
        }
        public void unregisterCallback(BindActivityAIDL callback) {
            // CallbackXg
            callbackList.unregister(callback);
        }
    };

    // TimerTaskIuWFNg
    private TimerTask task = new TimerTask() {
        @Override
        public void run() {
        	// 10bƂɃJEgAbv
        	countTime += 10;
        	
            // Callback̃XgJn
            int n = callbackList.beginBroadcast();
            // SACe[v
            for (int i = 0; i < n; i++) {
                try {
                    // ANeBreBdisplayTime\bhs
                    callbackList.getBroadcastItem(i).displayTime(
                    		countTime / 60 + 
                            ""+ 
                            countTime % 60+"bo߂܂I");
                } catch (RemoteException e) {
                    Log.e("ERROR", e.getMessage());
                }
            }
            // Callback̃XgI
            callbackList.finishBroadcast();
        }
    };
}
